# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .open_api_array_property import OpenApiArrayProperty
from .open_api_integer_property import OpenApiIntegerProperty
from .open_api_number_property import OpenApiNumberProperty
from .open_api_object_property import OpenApiObjectProperty
from .open_api_property import OpenApiProperty


class MlModelParameterConfig(pydantic_v1.BaseModel):
    temperature: typing.Optional[OpenApiNumberProperty] = None
    max_tokens: typing.Optional[OpenApiIntegerProperty] = None
    stop: typing.Optional[OpenApiArrayProperty] = None
    top_p: typing.Optional[OpenApiNumberProperty] = None
    top_k: typing.Optional[OpenApiIntegerProperty] = None
    frequency_penalty: typing.Optional[OpenApiNumberProperty] = None
    presence_penalty: typing.Optional[OpenApiNumberProperty] = None
    logit_bias: typing.Optional[OpenApiObjectProperty] = None
    custom_parameters: typing.Optional[typing.Dict[str, typing.Optional[OpenApiProperty]]] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
