# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .search_result_document import SearchResultDocument
from .search_result_meta import SearchResultMeta


class SearchResult(pydantic_v1.BaseModel):
    text: str = pydantic_v1.Field()
    """
    The text of the chunk that matched the search query.
    """

    score: float = pydantic_v1.Field()
    """
    A score representing how well the chunk matches the search query.
    """

    keywords: typing.List[str]
    document: SearchResultDocument = pydantic_v1.Field()
    """
    The document that contains the chunk that matched the search query.
    """

    meta: typing.Optional[SearchResultMeta] = pydantic_v1.Field(default=None)
    """
    Additional information about the search result.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
